using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Text;
using System.Data;
//using Jefferies.Core.Data;
using Jefferies.Common.Data.Sql.DataModel;
using Jefferies.Common.Data.Sql.DataAccess;

namespace Jefferies.IPM.UI.Module.NewIssue
{
	public class NewIssueOrder : RecordBase
	{
		private const string _tableName = "NewIssueOrder";
		private static string[] _keys = { "NewIssueId", "Mnkr", "BookEntity"};//, "Acct", "AcctType"};
		private bool _isNew = true;

		public NewIssueOrder(DataRow dr) : base(dr)
		{
		}

		public NewIssueOrder(): base()
		{
		}
		public void Save(bool isNew)
		{
			_isNew	= isNew;
			this.Save();
		}
		//public override void Save()

		public void Save()
		{
			//SqlDataManager dm = new SqlDataManager(ApplicationController.Current.Context.Config.IOMMasterDBConnectionString);
			//SqlTable table = new SqlTable();
			//table.TableName = _tableName;

			////if (this.NewIssueId == 0) // it's a new record
			//if (_isNew)
			//{
			//    dm.Insert(table, Values);
			//}
			//else //it's an existing record
			//{
			//    //generate list of primary keys
			//    ValueList keys = new ValueList();
			//    for (int i = 0; i < _keys.Length; i++)
			//    {
			//        keys.Add(_keys[i], Values[_keys[i]]);
			//    }

			//    dm.Update(table, Values, keys);
			//}
		}
		#region properties

		public bool IsNew
		{
			get
			{
				return _isNew;
			}
			set
			{
				_isNew = value;
			}
		}

		public int NewIssueId               
		{
			get
			{
				return SqlDataManager.GetIntFromDB(Values["NewIssueId"]);
			}
			set
			{
				Values["NewIssueId"] = value;
			}
		}
		public string Mnkr                  
		{
			get
			{
				return SqlDataManager.GetStringFromDB(Values["Mnkr"]);
			}
			set
			{
				Values["Mnkr"] = value;
			}
		}
		public string MnkrName              
		{
			get
			{
				return SqlDataManager.GetStringFromDB(Values["MnkrName"]);
			}
			set
			{
				Values["MnkrName"]	= value;
			}
		}
		public string BookEntity            
		{
			get
			{
				return SqlDataManager.GetStringFromDB(Values["BookEntity"]);
			}
			set
			{
				Values["BookEntity"] = value;
			}
		} 
		public int Cheap                    
		{
			get
			{
				return SqlDataManager.GetIntFromDB(Values["Cheap"]);
			}
			set
			{
				Values["Cheap"] = value;
			}
		}
		public int Mids                     
		{
			get
			{
				return SqlDataManager.GetIntFromDB(Values["Mids"]);
			}
			set
			{
				Values["Mids"] = value;
			}
		}
		public int Rich                     
		{
			get
			{
				return SqlDataManager.GetIntFromDB(Values["Rich"]);
			}
			set
			{
				Values["Rich"] = value;
			}
		}
        public int RequestedHedge           
        {
			get
			{
				return SqlDataManager.GetIntFromDB(Values["RequestedHedge"]);
			}
            set { Values["RequestedHedge"] = value; }
        }
        public int StockOrderQuantity       
        {
            get
            {
				return SqlDataManager.GetIntFromDB(Values["StockOrderQuantity"]);
            }
            set
            {
                Values["StockOrderQuantity"] = value;
            }
        }
        public int OrderQuantity            
		{
			get
			{
				return SqlDataManager.GetIntFromDB(Values["OrderQuantity"]);
			}
			set
			{
				Values["OrderQuantity"] = value;
			}
		}
		public string Comments              
		{
			get
			{
				return SqlDataManager.GetStringFromDB(Values["Comments"]);
			}
			set
			{
				Values["Comments"] = value;
			}
		}
		public string AE                    
		{
			get
			{
				return SqlDataManager.GetStringFromDB(Values["AE"]);
			}
			set
			{
				Values["AE"] = value;
			}
		}
		public string Capacity              
		{
			get
			{
				return SqlDataManager.GetStringFromDB(Values["Capacity"]);
			}
			set
			{
				Values["Capacity"] = value;
			}
		}
        public int StockAllocatedQuantity   
        {
            get
            {
				return SqlDataManager.GetIntFromDB(Values["StockAllocatedQuantity"]);
            }
            set
            {
                Values["StockAllocatedQuantity"] = value;
            }
        }
        public int ReqStockAllocQty         
        {
			get
			{
				return SqlDataManager.GetIntFromDB(Values["ReqStockAllocQty"]);
			}
            set { Values["ReqStockAllocQty"] = value; ; }
        }
        public int FinalStockAllocQty       
        {
			get
			{
				return SqlDataManager.GetIntFromDB(Values["FinalStockAllocQty"]);
			}
            set { Values["FinalStockAllocQty"] = value; ; }
        }
        public int AllocatedQuantity        
		{
			get
			{
				return SqlDataManager.GetIntFromDB(Values["AllocatedQuantity"]);
			}
			set
			{
				Values["AllocatedQuantity"] = value;
			}
		}
		public int RowOrder                 
		{
			get
			{
				return SqlDataManager.GetIntFromDB(Values["RowOrder"]);
			}
			set
			{
				Values["RowOrder"] = value;
			}
		}
		public int BondOrderId              
		{
			get
			{
				return SqlDataManager.GetIntFromDB(Values["BondOrderId"]);
			}
			set
			{
				Values["BondOrderId"] = value;
			}
		}
		public int StockOrderId             
		{
			get
			{
				return SqlDataManager.GetIntFromDB(Values["StockOrderId"]);
			}
			set{ Values["StockOrderId"] = value;}
		}


		#endregion

	}
}
