using System;
using System.Collections.Generic;
using System.Text;

using Jefferies.IPM.UI.Module.NewIssue.Model;
//using Jefferies.Core.Data;
using System.Windows.Forms;
using System.ComponentModel;
using Jefferies.Common.Data.Collections.GridHelper;
using Jefferies.Common.Data.Sql.DataAccess;

namespace Jefferies.IPM.UI.Module.NewIssue.Model
{
	public class NewIssueOrderItem : RowItem
	{
		private float _orderPercentage	= 0;
		private float _allocPercentage	= 0;

		public NewIssueOrderItem(NewIssueOrder newIssueOrder)
		{
			Data	= newIssueOrder;
		}

		public NewIssueOrderItem()
		{
			Data = new NewIssueOrder();
		}

		public NewIssueOrder NewIssueOrder
		{
			get
			{
				return (NewIssueOrder) Data;
			}
		}

		[RowItemFormat("Moniker", Width=50)]
		public string Mnkr
		{
			get
			{
				return ((NewIssueOrder) Data).Mnkr;
			}
			set
			{
				((NewIssueOrder) Data).Mnkr = value;
			}
		}

		[RowItemFormat("Moniker Name", Width=80, ReadOnly=true)]
		public string MnkrName
		{
			get
			{
				return ((NewIssueOrder) Data).MnkrName;
			}
			set
			{
				((NewIssueOrder) Data).MnkrName = value;
			}
		}

		[RowItemFormat("Cheap", Format = SqlDataManager.QuantityFormat, Width = 90)]
		public int Cheap
		{
			get
			{
				return ((NewIssueOrder) Data).Cheap;
			}
			set
			{
				((NewIssueOrder) Data).Cheap = value;
			}
		}

		[RowItemFormat("Mid", Format = SqlDataManager.QuantityFormat, Width = 90)]
		public int Mids
		{
			get
			{
				return ((NewIssueOrder) Data).Mids;
			}
			set
			{
				((NewIssueOrder) Data).Mids = value;
			}
		}

		[RowItemFormat("Rich", Format = SqlDataManager.QuantityFormat, Width = 90)]
		public int Rich
		{
			get
			{
				return ((NewIssueOrder) Data).Rich;
			}
			set
			{
				((NewIssueOrder) Data).Rich = value;
			}
		}

		[RowItemFormat("Requested Hedge", Format = SqlDataManager.QuantityFormat, Width = 130)]
        public int RequestedHedge
        {
            get
            {
				return ((NewIssueOrder) Data).RequestedHedge;
            }
            set
            {
				((NewIssueOrder) Data).RequestedHedge = value;
            }
        }
        
        [RowItemFormat("Strategy", Width = 50)]
        public string Capacity
        {
            get
            {
				return ((NewIssueOrder) Data).Capacity;
            }
            set
            {
				((NewIssueOrder) Data).Capacity = value;
            }
        }

		[RowItemFormat("Bond Order Quantity", Format = SqlDataManager.QuantityFormat, Width = 130)]
		public int OrderQuantity
		{
			get
			{
				return ((NewIssueOrder) Data).OrderQuantity;
			}
			set
			{
				((NewIssueOrder) Data).OrderQuantity = value;
			}
		}

		[RowItemFormat("Stock Order Quantity", Format = SqlDataManager.QuantityFormat, Width = 130, ReadOnly = false)]
        public int StockOrderQuantity
		{
			get
			{
				return ((NewIssueOrder) Data).StockOrderQuantity;
			}
			set
			{
				((NewIssueOrder) Data).StockOrderQuantity = value;
			}
		}

		[RowItemFormat("Order % of Total", Format = SqlDataManager.FeeFormat, ReadOnly = true, Width = 100)]
		public float OrderPercentage
		{
			get
			{
				return _orderPercentage;
			}
			set
			{
				_orderPercentage	= value;
			}
		}

		[RowItemFormat("Comments", Width=100)]
		public string Comments
		{
			get
			{
				return ((NewIssueOrder) Data).Comments;
			}
			set
			{
				((NewIssueOrder) Data).Comments = value;
			}
		}

		[RowItemFormat("AE", Width=40)]
		public string AE
		{
			get
			{
				return ((NewIssueOrder) Data).AE;
			}
			set
			{
				((NewIssueOrder) Data).AE = value;
			}
		}

		[RowItemFormat("Bond Allocated Quantity", Format = SqlDataManager.QuantityFormat, Width = 130)]
		public int AllocatedQuantity
		{
			get
			{
				return ((NewIssueOrder) Data).AllocatedQuantity;
			}
			set
			{
				((NewIssueOrder) Data).AllocatedQuantity = value;
			}
		}

		[RowItemFormat("Stock Allocated Quantity", Format = SqlDataManager.QuantityFormat, Width = 130, ReadOnly = true)]
        public int StockAllocatedQuantity
		{
			get
			{
				return ((NewIssueOrder) Data).StockAllocatedQuantity;
			}
			set
			{
				((NewIssueOrder) Data).StockAllocatedQuantity = value;
			}
		}

		[RowItemFormat("Req Stock Hedge Alloc Qty", Format = SqlDataManager.QuantityFormat, Width = 130, ReadOnly = true)]
        public int ReqStockAllocQty
        {
            get
            {
				return ((NewIssueOrder) Data).ReqStockAllocQty;
            }
            set
            {
				((NewIssueOrder) Data).ReqStockAllocQty = value;
            }
        }

		[RowItemFormat("Final Stk Alloc Qty", Format = SqlDataManager.QuantityFormat, Width = 130, ReadOnly = false)]
        public int FinalStockAllocQty
        {
            get
            {
				return ((NewIssueOrder) Data).FinalStockAllocQty;
            }
            set
            {
				((NewIssueOrder) Data).FinalStockAllocQty = value;
            }
        }

		[RowItemFormat("Alloc % of Total", Format = SqlDataManager.FeeFormat, ReadOnly = true, Width = 90)]
		public float AllocatedPercentage
		{
			get
			{
				return _allocPercentage;
			}
			set
			{
				_allocPercentage	= value;
			}
		}

		[RowItemFormat("% of Requested", ReadOnly = true, Width = 90, Format = SqlDataManager.FeeFormat)]
		public float RequestedPercentage
		{
			get
			{
				return ((float) ((NewIssueOrder) Data).AllocatedQuantity / (float) ((NewIssueOrder) Data).OrderQuantity * 100);
			}
		}

	}
}